//
//      SGRNetworkDialogSet.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.5
//

#ifndef __SGRNETWORKDIALOGSET_HPP
#define __SGRNETWORKDIALOGSET_HPP

#include <SophiaFramework.hpp>
#include "SGRSoftkeyToolbox.hpp"
#include "SGRErrorDialogSet.hpp"

SFMTYPEDEFCLASS(SGRNetworkDialogSet)
class SGRNetworkDialogSet {
    SFMSEALCOPY(SGRNetworkDialogSet)
public:
    enum NotifyEnum {
        NOTIFY_CONNECT_START,
        NOTIFY_CONNECT_CANCEL,
        NOTIFY_CONNECT_END,
        NOTIFY_ERROR
    };
    typedef Void (*NetworkDialogSetSPP)(NotifyEnum, SFCError, VoidPtr);
private:
    SFXHTTPConnection _http;
    SFXAnsiString _string;
    SFXAnsiString _url;
    NetworkDialogSetSPP _spp;
    VoidPtr _reference;
    SFRDialogPtr _dialog;
	SFXAnsiString _ok;
	SFXAnsiString _cancel;
	SFXAnsiString _text;
	SFXAnsiString _title;
	SFXAnsiString _asin;
	SGRErrorDialogSet _errorDialog;
	SFXConfig _config;

	SFXFile _file;				   // XML t@C
    SFXBinaryStreamWriter _writer; // t@Cݗpo̓Xg[
    SFXBuffer _receivedBuffer;     // Mf[^i[obt@
    SFXBuffer _tempBuffer;         // Mf[^ꎞi[obt@
    UInt32 _bufferSize;            // Xg[̃obt@TCY
	SFXPath _path;				   // XML t@CۑpX

	Bool _connecting; // lbg[N Xe[^X
	SFXSOAPWriter _soapwriter;
    SFXBinaryStreamReader           _stream;


public:
    SGRNetworkDialogSet(Void);
    virtual ~SGRNetworkDialogSet(Void);
    SFCError Open(Bool isConfirm, NetworkDialogSetSPP procedure, VoidPtr data, SFXAnsiStringConstRef title, SFXAnsiStringConstRef text, SFXAnsiStringConstRef ok, SFXAnsiStringConstRef cancel,SFXWideStringConstRef asin);
	SFXAnsiStringConstRef GetText() { return _string; }
    Void ClearText() { _string.Clear(); }

	Void ClearData(Void) { _receivedBuffer.Free(); }
	Bool IsConnecting(Void) { return _connecting;}
private:
    Void ProceedNetworkError(Void);
    SFCError Connect(Void);

    HANDLER_DECLARE_VOIDDIALOG(OnDialog)
	HANDLER_DECLARE_VOIDDIALOG(OnReceiving)
    CALLBACK_DECLARE_SFXHTTPCONNECTION(ConnectCallback)
    CALLBACK_DECLARE_SFXBINARYSTREAMREADER(FetchCallback)
	HANDLER_DECLARE_VOIDSUSPEND(OnSuspend)
	HANDLER_DECLARE_VOIDRESUME(OnResume)

	Void SGRNetworkDialogSet::Error_Http(Void);
	Void SGRNetworkDialogSet::Error_File(Void);
	Void SGRNetworkDialogSet::Error_Funciton(SFCError error, SFXAnsiStringConstRef title, SFXAnsiStringConstRef text, SFXAnsiStringConstRef ok, VoidPtr data);

};


#endif //__SGRNETWORKDIALOGSET_HPP //
